/* Peterson mutual exclusion algorithm */

/* shared variables */
bit turn;
bit w[2];  /* process w[i] is waiting */
bit c[2];  /* process c[i] is in the critical section */

proctype P (bit i)
{
  do
  :: skip -> {
    w[i] = 1;
    turn = 1-i;    
    /* wait until */ ( turn == i || !w[1-i] );

    c[i] = 1;
    /* critical code */
    c[i] = 0;

    w[i] = 0;
  }
  od
}

init
{
  atomic { run P(0); run P(1); }
}
